package edu.mermet.tp8.fenetres;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import edu.mermet.tp8.*;

/**
 *
 * @author brunomermet
 */
public class FenetreConversion extends AbstractFenetreInterne {
    private JTextField champCelsius;
    private JTextField champFarenheit;
    private JButton boutonConvertir;
    private Action actionConvertir;
    private boolean celsiusAFocus;
    private JPopupMenu popupMenuC;
    private JPopupMenu popupMenuF;
    public FenetreConversion(JFrame frame, Action action) {
        super(action,"Conversion celsius/Farenheit");
        this.setSize(new Dimension(100,50));
        this.setLayout(new GridLayout(3,1));
        creerPopupMenu();
        JPanel ligneCelsius = new JPanel();
        ligneCelsius.setLayout(new FlowLayout(FlowLayout.TRAILING));
        JLabel labCelsius = new JLabel("Celsius :");
        champCelsius = new JTextField(15);
        labCelsius.setLabelFor(champCelsius);
        JLabel iconeAideCelsius = new JLabel(new ImageIcon(this.getClass().getResource("/images/interrogation.png")));
        iconeAideCelsius.addMouseListener(new MouseAdapterAide(this, "Valeur en degré Celsius"));
        ligneCelsius.add(labCelsius);
        ligneCelsius.add(champCelsius);
        ligneCelsius.add(iconeAideCelsius);
        this.add(ligneCelsius);
        celsiusAFocus = true;
        champCelsius.addFocusListener(new EcouteurFocus(true));
        champCelsius.setToolTipText("Valeur en degrés Celsius");
        champCelsius.addMouseListener(new MouseAdapterContextuel("Valeur en degrés Celsius", popupMenuC));
        champCelsius.add(popupMenuC);
        champCelsius.setComponentPopupMenu(popupMenuC);
        JPanel ligneFarenheit = new JPanel();
        ligneFarenheit.setLayout(new FlowLayout(FlowLayout.TRAILING));
        JLabel labFarenheit = new JLabel("Farenheit :");
        champFarenheit = new JTextField(15);
        champFarenheit.setToolTipText("Valeur en degrés Farenheit");
        champFarenheit.addMouseListener(new MouseAdapterContextuel("Valeur en degrés Farenheit", popupMenuF));
        champFarenheit.add(popupMenuF);
        champFarenheit.setComponentPopupMenu(popupMenuF);
        labFarenheit.setLabelFor(champFarenheit);
        JLabel iconeAideFarenheit = new JLabel(new ImageIcon(this.getClass().getResource("/images/interrogation.png")));
        iconeAideFarenheit.addMouseListener(new MouseAdapterAide(this, "Valeur en degré Farenheit"));
        ligneFarenheit.add(labFarenheit);
        ligneFarenheit.add(champFarenheit);
        ligneFarenheit.add(iconeAideFarenheit);
        this.add(ligneFarenheit);
        champFarenheit.addFocusListener(new EcouteurFocus(false));
        JPanel ligneValider = new JPanel();
        ligneValider.setLayout(new FlowLayout(FlowLayout.CENTER));
        actionConvertir = new ActionConvertir();
        boutonConvertir = new JButton(actionConvertir);
        ligneValider.add(boutonConvertir);
        this.add(ligneValider);

        pack();
        getRootPane().setDefaultButton(boutonConvertir);
    }

    public void creerPopupMenu()
    {
        popupMenuC = new JPopupMenu();
        JMenuItem menuAideC = new JMenuItem("Aide");
        menuAideC.setMnemonic('A');
        menuAideC.addMouseListener(new MouseAdapterAide(this, "Valeur en degré Celsius"));
        popupMenuC.add(menuAideC);

        popupMenuF = new JPopupMenu();
        JMenuItem menuAideF = new JMenuItem("Aide");
        menuAideF.setMnemonic('A');
        menuAideF.addMouseListener(new MouseAdapterAide(this, "Valeur en degré Farenheit"));
        popupMenuF.add(menuAideF);
    }

    public void afficherDialog(String aide)
    {
        JOptionPane d = new JOptionPane();
        d.showMessageDialog(this, aide, "Aide", JOptionPane.INFORMATION_MESSAGE);
    }

    private class EcouteurFocus implements FocusListener {
        private boolean aStocker;

        public EcouteurFocus(boolean b) {
            aStocker = b;
        }

        @Override
        public void focusGained(FocusEvent fe) {
            celsiusAFocus = aStocker;
        }

        @Override
        public void focusLost(FocusEvent fe) {
            return;
        }
    }

    private class ActionConvertir extends AbstractAction {

        public ActionConvertir() {
            super("Convertir");
        }

        @Override
        public void actionPerformed(ActionEvent ae) {
            double tempCelsius = 0;
            double tempFarenheit = 0;
            if (celsiusAFocus) {
                try {
                    tempCelsius = Double.parseDouble(champCelsius.getText());
                tempFarenheit = 9./5*tempCelsius+32;
                champFarenheit.setText(""+tempFarenheit);
                }
                catch (NumberFormatException nfe) {
                    champFarenheit.setText("Format incorrect");
                }
                }
            else {
                try {
                    tempFarenheit = Double.parseDouble(champFarenheit.getText());
                    tempCelsius = (tempFarenheit - 32) *5./9;
                    champCelsius.setText(""+tempCelsius);
                }
                catch (NumberFormatException nfe) {
                    champCelsius.setText("Format incorrect");
                }
                
            }
        }
    }

    private class MouseAdapterAide extends MouseAdapter {
        FenetreConversion fenetre;
        String aide;

        public MouseAdapterAide(FenetreConversion fenetre, String aide) {
            this.fenetre = fenetre;
            this.aide = aide;
        }

        @Override
        public void mousePressed(MouseEvent me) {
            fenetre.afficherDialog(aide);
        }
    }

    private class MouseAdapterContextuel extends MouseAdapter {
        String aide;
        JPopupMenu popupMenu;

        public MouseAdapterContextuel(String aide, JPopupMenu popupMenu)
        {
            this.aide = aide;
            this.popupMenu = popupMenu;
        }

        @Override
        public void mousePressed( MouseEvent event ) {
            if ( event.isPopupTrigger() ) {
                popupMenu.show( event.getComponent(), event.getX(), event.getY() );
            }
        }
    }
    
}
