package edu.mermet.tp8.fenetres;

import edu.mermet.tp8.*;
import utilisateur.InfoUtilisateur;

import java.awt.*;
import java.awt.event.*;
import java.util.*;
import javax.swing.*;

/**
 *
 * @author Paul LEVRAGUE
 */
public class FenetreSuggestion extends JDialog {
	private static final String[] NOM_SUGGESTIONS = new String[] {"quitter", "diaporama", "conversion", "texte", "boutons"};
	
	private static InfoUtilisateur info = InfoUtilisateur.getInstance();

    private String suggestion;
    private JButton btnFermer;
    private JButton btnNePlusAfficher;

    public FenetreSuggestion(Application app) {
        super(app, "Suggestion du jour", true);
        setLayout(new BorderLayout());
        setUndecorated(true);
        getRootPane().setBorder(BorderFactory.createLineBorder(Color.BLACK));

        JEditorPane editorPane = new JEditorPane("text/html", getSuggestionAlea(app.getNbSuggestion()));
        
        JPanel pnlBtn = new JPanel(new FlowLayout());

        btnFermer = new JButton("Fermer");
        btnNePlusAfficher = new JButton("Ne plus afficher");
        
        btnFermer.addActionListener(new ActionFermer());
        btnNePlusAfficher.addActionListener(new ActionNePlusAfficher());

        pnlBtn.add(btnFermer);
        pnlBtn.add(btnNePlusAfficher);

        add(editorPane);
        add(pnlBtn, BorderLayout.SOUTH);

        pack();
        this.setLocationRelativeTo(null);
        setVisible(true);
    }

    public String getSuggestionAlea(int nbSuggestions)
    {
		do
		{
			int alea = (int)(Math.random()*nbSuggestions);

			suggestion = NOM_SUGGESTIONS[alea] + getTypeAlea();
		} while (suggestionExclue(suggestion));

		ResourceBundle res = ResourceBundle.getBundle("suggestion.suggestions");
		String txtSuggestion = (String)res.getObject(suggestion);

		return txtSuggestion;
    }

    //Les suggestions sont soit une suggestion de raccourci soit de description
    public char getTypeAlea()
    {
    	int alea = (int)(Math.random()*2);

    	return (alea==0) ? 'R' : 'D';
    }

    public boolean suggestionExclue(String txt)
    {
    	return info.getDonnee(txt) != null;
    }

    class ActionFermer implements ActionListener {
    	@Override
    	public void actionPerformed(ActionEvent ae)	{
    		dispose();
    	}
    }

    class ActionNePlusAfficher implements ActionListener {
    	@Override
    	public void actionPerformed(ActionEvent ae)	{
    		info.sauvegarde(suggestion, "exclue");
    		dispose();
    	}
    }

}
