package edu.mermet.tp8.fenetres;

import edu.mermet.tp8.*;

import java.awt.*;
import java.awt.event.ActionEvent;
import java.util.*;
import javax.swing.*;
import javax.swing.event.*;

/**
 *
 * @author Paul LEVRAGUE
 */
public class FrameAide extends AbstractFenetre
{
	private static final String[] keyTitres = new String[] {"conversion_1", "conversion_2", "gras", "couleur"};
	
	private JEditorPane editorPane;
	private JList<String> list;

	public FrameAide(Action monAction, JFrame frame)
	{
		super(frame, monAction, "Comment faire ?");
		setLayout(new BorderLayout());

		this.list = new JList<>(chargerTitres());
		list.setSelectionMode(DefaultListSelectionModel.SINGLE_SELECTION);
		list.addListSelectionListener(new ListSelectionAide());

		this.editorPane = new JEditorPane();
		editorPane.setContentType("text/html");
		editorPane.setEditable(false);
		
		list.setSelectedIndex(0);
		JSplitPane split = new JSplitPane(JSplitPane.HORIZONTAL_SPLIT, list, editorPane);
		split.setResizeWeight(0.5);
        split.setContinuousLayout(true);
		add(split);

		this.setLocationRelativeTo(null);
		pack();
	}

	public String[] chargerTitres()
	{
		ResourceBundle res = ResourceBundle.getBundle("HowTo.titres"); 
		String[] titres = new String[keyTitres.length];

		for (int i=0; i<keyTitres.length; i++)
			titres[i] = (String)res.getObject(keyTitres[i]);

		return titres;
	}

	class ListSelectionAide implements ListSelectionListener
	{
	    public void valueChanged(ListSelectionEvent e)
	    {
        	ResourceBundle res = ResourceBundle.getBundle("HowTo.textes");
			String texte = (String)res.getObject(keyTitres[list.getSelectedIndex()]); 

        	editorPane.setText(texte);
	    }
	}
}
